diff --git a/core/src/aos_sssp.c b/core/src/aos_sssp.c
index 8f82143..90ceab1 100644
--- a/core/src/aos_sssp.c
+++ b/core/src/aos_sssp.c
@@ -642,6 +764,516 @@ aos_status_t aosSsspProceed(event_listener_t* listener, eventflags_t flags, even
   return status;
 }
 
+#if (AMIROOS_CFG_SSSP_MSI == true) || defined(__DOXYGEN__)
+
+/**
+ * @brief   Initialize MSI data structure.
+ *
+ * @param[out]  msidata       Pointer to the MSI data structure to be initialized.
+ * @param[in]   delayMask     Event maks used for delay events.
+ * @param[in]   timeoutMask   Event mask used for timeout events.
+ * @param[in]   gpioListener  Event listener for GPIO events.
+ */
+void aosSsspMsiInit(aos_ssspmsidata_t* msidata, eventmask_t delayMask, eventmask_t timeoutMask, event_listener_t* gpioListener)
+{
+  aosDbgCheck(msidata != NULL);
+  aosDbgCheck(gpioListener != NULL);
+
+  // register delay events
+  chEvtRegisterMask(&_delayEventSource, &_delayEventListener, delayMask);
+
+  // initialize timeout related data
+  chVTObjectInit(&msidata->timeout.timer);
+  chEvtObjectInit(&msidata->timeout.eventsource);
+  chEvtRegisterMask(&msidata->timeout.eventsource, &msidata->timeout.eventlistener, timeoutMask);
+
+  // set GPIO event information
+  msidata->signals.eventlistener = gpioListener;
+
+  // initialize BCB related data
+  msidata->bcb.lastid = AOS_SSSP_MODULEID_INVALID;
+
+  return;
+}
+
+/**
+ * @brief   Execute module stack initialization (MSI).
+ *
+ * @param[in]   msidata   Data required for MSI.
+ * @param[out]  received  Output variable to store the received event mask to.
+ */
+void aosSsspMsi(aos_ssspmsidata_t* msidata, eventmask_t* received)
+{
+  aosDbgCheck(msidata != NULL);
+  aosDbgCheck(received != NULL);
+
+  /*
+   * execute anything that does not depend on BCB messages or events
+   */
+  switch (aos.sssp.stage) {
+    case AOS_SSSP_STAGE_STARTUP_3:
+    case AOS_SSSP_STAGE_STARTUP_3_1:
+    {
+      aosDbgPrintf(">>> MSI init\n");
+      // setup timeout timer
+      chVTSet(&msidata->timeout.timer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &msidata->timeout.eventsource);
+      // proceed
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+      aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_1_BROADCASTINIT;
+#else /* (AMIROOS_CFG_SSSP_MASTER == true) */
+      aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_1_WAITFORINIT;
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+      break;
+    }
+
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+    case AOS_SSSP_STAGE_STARTUP_3_1_BROADCASTINIT:
+    {
+      aosDbgPrintf("%u\tsend INIT\t", chVTGetSystemTime());
+      // send init command
+      msidata->bcb.message.type = AOS_SSSP_BCBMESSAGE_MSIINIT;
+      _serializeBcbMessage(msidata->bcb.buffer, msidata->bcb.message);
+      if (moduleSsspBcbTransmit(msidata->bcb.buffer, sizeof(aos_ssspbcbmessage_t)) == AOS_SSSP_BCB_SUCCESS) {
+        aosDbgPrintf("ok\tS+\t");
+        // activate S
+        apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_ON);
+        // restart timeout timer
+        chVTSet(&msidata->timeout.timer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &msidata->timeout.eventsource);
+        // proceed
+#if (AMIROOS_CFG_SSSP_STACK_START == true)
+        aosDbgPrintf("->start\n");
+        aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_2;
+#else /* (AMIROOS_CFG_SSSP_STACK_START == true) */
+        aosDbgPrintf("->count\n");
+        aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_3_WAIT4EVENT;
+#endif /* (AMIROOS_CFG_SSSP_STACK_START == true) */
+      } else {
+        aosDbgPrintf("fail\t->retry\n");
+        // retry in next iteration
+      }
+      break;
+    }
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+
+#if (AMIROOS_CFG_SSSP_STACK_START == true)
+    case AOS_SSSP_STAGE_STARTUP_3_2:
+    {
+      aosDbgPrintf("%u\tstart\t", chVTGetSystemTime());
+      // set the own module ID
+      aos.sssp.moduleId = 1;
+      // broadcast the new ID
+      msidata->bcb.message.type = AOS_SSSP_BCBMESSAGE_MSIID;
+      msidata->bcb.message.payload.id = aos.sssp.moduleId;
+      aosDbgPrintf("bc ID (%u)\t", msidata->bcb.message.payload.id);
+      _serializeBcbMessage(msidata->bcb.buffer, msidata->bcb.message);
+      if (moduleSsspBcbTransmit(msidata->bcb.buffer, sizeof(aos_ssspbcbmessage_t)) == AOS_SSSP_BCB_SUCCESS) {
+        aosDbgPrintf("ok\t->count\n");
+        // restart timeout timer
+        chVTSet(&msidata->timeout.timer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &msidata->timeout.eventsource);
+        // set delay timer so UP will be activated and S deactivated later
+        chVTSet(&_delayTimer, chTimeUS2I(AOS_SSSP_DELAY), _timerCallback, &_delayEventSource);
+        // store the transmitted ID
+        msidata->bcb.lastid = msidata->bcb.message.payload.id;
+        // proceed
+        aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_3_WAIT4EVENT;
+      } else {
+        aosDbgPrintf("fail\t->retry\n");
+        // retry next iteration
+      }
+      break;
+    }
+#endif /* (AMIROOS_CFG_SSSP_STACK_START == true) */
+
+    case AOS_SSSP_STAGE_STARTUP_3_3_BROADCASTID:
+    {
+      // broadcast ID
+      msidata->bcb.message.type = AOS_SSSP_BCBMESSAGE_MSIID;
+      msidata->bcb.message.payload.id = aos.sssp.moduleId;
+      aosDbgPrintf("%u\tbc ID (%u)\t", chVTGetSystemTime(), msidata->bcb.message.payload.id);
+      _serializeBcbMessage(msidata->bcb.buffer, msidata->bcb.message);
+      if (moduleSsspBcbTransmit(msidata->bcb.buffer, sizeof(aos_ssspbcbmessage_t)) == AOS_SSSP_BCB_SUCCESS) {
+        aosDbgPrintf("ok->count\n");
+        // restart timeout timer
+        chVTSet(&msidata->timeout.timer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &msidata->timeout.eventsource);
+        // set delay timer so UP will be activated and S deactivated later
+        chVTSet(&_delayTimer, chTimeUS2I(AOS_SSSP_DELAY), _timerCallback, &_delayEventSource);
+        // store the transmitted ID
+        msidata->bcb.lastid = msidata->bcb.message.payload.id;
+        // return to receiving
+        aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_3_WAIT4EVENT;
+      } else {
+        aosDbgPrintf("fail\t->retry\n");
+        // retry next iteration
+      }
+      break;
+    }
+
+    case AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_INIT:
+    {
+      aosDbgPrintf("%u\tabort\t", chVTGetSystemTime());
+      // reset timeout timer
+      chVTReset(&msidata->timeout.timer);
+      // transmit abort message
+      msidata->bcb.message.type = AOS_SSSP_BCBMESSAGE_MSIABORT;
+      _serializeBcbMessage(msidata->bcb.buffer, msidata->bcb.message);
+      if (moduleSsspBcbTransmit(msidata->bcb.buffer, sizeof(aos_ssspbcbmessage_t)) == AOS_SSSP_BCB_SUCCESS) {
+        aosDbgPrintf("ok\tS-\t->sync\n");
+        // deactivate S
+        apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_OFF);
+        // proceed
+        aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_SYNC;
+      } else {
+        aosDbgPrintf("fail\t->retry\n");
+        // retry next iteration
+      }
+      break;
+    }
+
+    default:
+    {
+      // all other stages depend on events or BCB messages and are thus handled below
+      break;
+    }
+  }
+
+  /*
+   * handle BCB messages
+   */
+  msidata->bcb.status = moduleSsspBcbReceive(msidata->bcb.buffer, sizeof(aos_ssspbcbmessage_t));
+  switch (msidata->bcb.status) {
+
+    /* VALID BCB MESSAGE
+     * A message was received via BCB that seems to be plausible.
+     * The first BCB message initiates the sequence once.
+     * During MSI an arbitrary number of IDs will be received.
+     * Abort messages can be received at any time.
+     */
+    case AOS_SSSP_BCB_SUCCESS:
+    {
+      aosDbgPrintf("%u\tBCB\t", chVTGetSystemTime());
+      // deserialize message and handle types differently
+      _deserializeBcbMessage(&msidata->bcb.message, msidata->bcb.buffer);
+      switch (msidata->bcb.message.type) {
+        // initialization message
+        case AOS_SSSP_BCBMESSAGE_MSIINIT:
+        {
+#if (AMIROOS_CFG_SSSP_MASTER == true)
+          aosDbgPrintf("INIT\t->abort\n");
+          // initiate abortion
+          aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_INIT;
+#else /* (AMIROOS_CFG_SSSP_MASTER == true) */
+          aosDbgPrintf("INIT\t");
+          // check for correct SSSP stage
+          if (aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_3_1_WAITFORINIT) {
+            aosDbgPrintf("S+\t");
+            // activate S
+            apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_ON);
+            // restart timeout timer
+            chVTSet(&msidata->timeout.timer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &msidata->timeout.eventsource);
+            // proceed
+#if (AMIROOS_CFG_SSSP_STACK_START == true)
+            aosDbgPrintf("->start\n");
+            aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_2;
+#else /* (AMIROOS_CFG_SSSP_STACK_START == true) */
+            aosDbgPrintf("->count\n");
+            aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_3_WAIT4EVENT;
+#endif /* (AMIROOS_CFG_SSSP_STACK_START == true) */
+          } else {
+            aosDbgPrintf("->abort\n");
+            // initiate abortion
+            aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_INIT;
+          }
+#endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
+          break;
+        }
+        // ID message
+        case AOS_SSSP_BCBMESSAGE_MSIID:
+        {
+          aosDbgPrintf("ID (%u)\t", msidata->bcb.message.payload.id);
+          // check for correct stage and whether ID was increased
+          if (aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_3_3_WAIT4EVENT &&
+              msidata->bcb.message.payload.id > msidata->bcb.lastid) {
+            aosDbgPrintf("ok\n");
+            // restart timeout timer
+            chVTSet(&msidata->timeout.timer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &msidata->timeout.eventsource);
+            // store ID
+            msidata->bcb.lastid = msidata->bcb.message.payload.id;
+          } else {
+            aosDbgPrintf("fail\t->abort\n");
+            // initiate abortion
+            aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_INIT;
+          }
+          break;
+        }
+        // abort message
+        case AOS_SSSP_BCBMESSAGE_MSIABORT:
+        {
+          aosDbgPrintf("ABORT\tS-\t->sync\n");
+          // reset timeout timer
+          chVTReset(&msidata->timeout.timer);
+          // deactivate S
+          apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_OFF);
+          // proceed to abort synchronization
+          aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_SYNC;
+          break;
+        }
+        // invalid message
+        default:
+        {
+          aosDbgPrintf("invalid\t->abort\n");
+          // initiate abortion
+          aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_INIT;
+          break;
+        }
+      }
+      return;
+    }
+
+    /* INVALID BCB MESSAGE
+     * An obviously invalid message was received via BCB.
+     */
+    case AOS_SSSP_BCB_INVALIDMSG:
+    {
+      // error but ignore
+      aosDbgPrintf("WARNING: unknown message received via BCB\n");
+      break;
+    }
+
+    /* NO BCB MESSAGE
+     * No message was received via BCB at all.
+     */
+    case AOS_SSSP_BCB_ERROR:
+    {
+      // do nothing and proceed
+      break;
+    }
+  }
+
+  /*
+   * handle events
+   */
+  *received = chEvtWaitOneTimeout(ALL_EVENTS, TIME_IMMEDIATE);
+  /* TIMEOUT EVENT
+   * Timeouts can occur at any time during MSI after they have been initialized.
+   * As soon as the module has made it to the 3.4 completion stage, there will be no more timeouts, though.
+   */
+  if (*received & msidata->timeout.eventlistener.events) {
+    aosDbgPrintf("%u\ttimeout\t", chVTGetSystemTime());
+    // special cases
+    if (aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_3_1_WAITFORINIT ||
+        aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_3_4_COMPLETION) {
+      // master did not initiate the sequence
+      if (aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_3_1_WAITFORINIT) {
+        aosDbgPrintf("no init\t->operation\n");
+        // invalidate module ID
+        aos.sssp.moduleId = AOS_SSSP_MODULEID_INVALID;
+        aosDbgPrintf("<<< MSI skipped\n");
+      }
+      // no abort messages received after completion
+      else /* if (aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_3_4_COMPLETION) */ {
+        aosDbgPrintf("success\t->operation\n");
+        aosDbgPrintf("<<< MSI completed\n");
+      }
+      // cleanup and proceed to operation phase
+      _msiOutro(msidata);
+    }
+    // general timeout
+    else {
+      aosDbgPrintf("->abort\n");
+      // initiate active abort
+      aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_INIT;
+    }
+    // clear event
+    chEvtGetAndClearFlags(&msidata->timeout.eventlistener);
+    *received &= ~(msidata->timeout.eventlistener.events);
+  }
+  /* DELAY EVENT
+   * Delays are only used to toggle the UP signal.
+   */
+  else if (*received & _delayEventListener.events) {
+    aosDbgPrintf("%u\tdelay\t", chVTGetSystemTime());
+#if (AMIROOS_CFG_SSSP_STACK_END == true)
+    apalControlGpioState_t s;
+    aosDbgPrintf("S-\t");
+    // deactivate S
+    apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_OFF);
+    // verify deactivation
+    apalControlGpioGet(moduleSsspSignalS(), &s);
+    if (s == APAL_GPIO_OFF) {
+      aosDbgPrintf("ok\t->done\n");
+      // set the timeout timer so no abort messages are missed
+      chVTSet(&msidata->timeout.timer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &msidata->timeout.eventsource);
+      // proceed to the completion stage
+      aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_COMPLETION;
+    } else {
+      aosDbgPrintf("fail\t->abort\n");
+      // initiate active abort
+      aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_INIT;
+    }
+#else /* (AMIROOS_CFG_SSSP_STACK_END == true) */
+    apalControlGpioState_t s;
+    // read the current state of the UP signal
+    apalControlGpioGet(moduleSsspSignalUP(), &s);
+    if (s == APAL_GPIO_OFF) {
+      aosDbgPrintf("UP+ & S-\n");
+      // activate UP in order to trigger the next module
+      apalControlGpioSet(moduleSsspSignalUP(), APAL_GPIO_ON);
+      // deactivate S
+      apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_OFF);
+      // set the delay timer so the UP signal will get deactivated again later
+      chVTSet(&_delayTimer, chTimeUS2I(AOS_SSSP_DELAY), _timerCallback, &_delayEventSource);
+    } else {
+      aosDbgPrintf("UP-\n");
+      // deactvate UP
+      apalControlGpioSet(moduleSsspSignalUP(), APAL_GPIO_OFF);
+    }
+#endif /* (AMIROOS_CFG_SSSP_STACK_END == true) */
+    // clear event
+    chEvtGetAndClearFlags(&_delayEventListener);
+    *received &= ~(_delayEventListener.events);
+  }
+  /* GPIO EVENT
+   * GPIO events can occurr at any time, but only DN and S events are expected.
+   * DN may be activated only once per module to trigger the counting process and is deactivated briefly after activation.
+   * S must only deactivate when MSI is comleted by the last module in the stack.
+   */
+  else if (*received & msidata->signals.eventlistener->events) {
+    aosDbgPrintf("%u\tGPIO\t", chVTGetSystemTime());
+    apalControlGpioState_t s;
+    // fetch event flags
+    eventflags_t flags = chEvtGetAndClearFlags(msidata->signals.eventlistener);
+#if (AMIROOS_CFG_SSSP_STACK_START != true)
+    // if the DN signal was triggered
+    if (flags & moduleSsspEventflagDN()) {
+      // read the signal state
+      apalControlGpioGet(moduleSsspSignalDN(), &s);
+      // rising edge
+      if (s == APAL_GPIO_ON) {
+        aosDbgPrintf("+DN\t");
+        // Correct SSSP stage and no ID assigned yet?
+        if (aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_3_3_WAIT4EVENT &&
+            aos.sssp.moduleId == AOS_SSSP_MODULEID_INVALID) {
+          // set the own module ID
+          aos.sssp.moduleId = msidata->bcb.lastid + 1;
+          aosDbgPrintf("set ID (%u)\t->bc ID\n", aos.sssp.moduleId);
+          // proceed to broadcasting
+          aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_3_BROADCASTID;
+        }
+        // incorrect SSSP stage or ID already assigned (triggered for a second time)
+        else {
+          aosDbgPrintf("->abort\n");
+          // initiate active abort
+          aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_INIT;
+        }
+      }
+      // falling egde
+      else {
+        aosDbgPrintf("-DN\n");
+        // ignored
+      }
+      // clear DN flags
+      flags &= ~moduleSsspEventflagDN();
+    }
+#endif /* (AMIROOS_CFG_SSSP_STACK_START != true) */
+#if (AMIROOS_CFG_SSSP_STACK_END != true)
+    // if the UP signal was triggered
+    if (flags & moduleSsspEventflagUP()) {
+      /*
+       * The UP signal is acting as output only.
+       * Any events resulting from toggling the signal are thus ignored.
+       */
+      aosDbgPrintf("?UP\n");
+      // clear UP flags
+      flags &= ~moduleSsspEventflagUP();
+    }
+#endif /* (AMIROOS_CFG_SSSP_STACK_END != true) */
+    // if the S signal was triggered
+    if (flags & moduleSsspEventflagS()) {
+      // read the signal state
+      apalControlGpioGet(moduleSsspSignalS(), &s);
+      // rising edge
+      if (s == APAL_GPIO_ON) {
+        aosDbgPrintf("+S\n");
+        // ignored
+      }
+      // falling edge
+      else {
+        aosDbgPrintf("-S\t");
+        // special case
+        if (aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_SYNC) {
+          aosDbgPrintf("->operation\n");
+          // invalidate module ID
+          aos.sssp.moduleId = AOS_SSSP_MODULEID_INVALID;
+          // proceed
+          aosDbgPrintf("<<< MSI aborted\n");
+          _msiOutro(msidata);
+        }
+#if (AMIROOS_CFG_SSSP_STACK_END == true)
+        // Correct SSSP stage?
+        else if (aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_3_4_COMPLETION) {
+          aosDbgPrintf("ok\n");
+          // ignored
+        } else {
+          aosDbgPrintf("->abort\n");
+          // initialize abortion
+          aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_INIT;
+        }
+#else /* (AMIROOS_CFG_SSSP_STACK_END == true) */
+        // Correct SSSP stage and ID assigned?
+        else if (aos.sssp.stage == AOS_SSSP_STAGE_STARTUP_3_3_WAIT4EVENT &&
+            aos.sssp.moduleId != AOS_SSSP_MODULEID_INVALID) {
+          aosDbgPrintf("->done\n");
+          // set the timeout timer so no abort messages are missed
+          chVTSet(&msidata->timeout.timer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &msidata->timeout.eventsource);
+          // proceed to the completion stage
+          aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_COMPLETION;
+        } else {
+          aosDbgPrintf("->abort\n");
+          // initiate abortion
+          aos.sssp.stage = AOS_SSSP_STAGE_STARTUP_3_4_ABORTION_INIT;
+        }
+#endif /* (AMIROOS_CFG_SSSP_STACK_END == true) */
+      }
+      // clear S flags
+      flags &= ~moduleSsspEventflagS();
+    }
+    // any further flags set?
+    if (flags) {
+      aosDbgPrintf("0x%08X\n", flags);
+      // reassign remaining flags and do not clear event mask
+      msidata->signals.eventlistener->flags |= flags;
+    } else {
+      // clear event
+      *received &= ~(msidata->signals.eventlistener->events);
+    }
+  }
+  /* OTHER EVENT
+   * Any other events may occur as well but are not handled by this function
+   */
+  else if (*received != 0){
+    aosDbgPrintf("%u\tOTHER\t0x%08X\n", chVTGetSystemTime(), *received);
+    // do not clear the event mask
+  }
+
+  return;
+}
+
+#endif /* (AMIROOS_CFG_SSSP_MSI == true) */
+
+#if ((AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true)) || defined(__DOXYGEN__)
+
+/**
+ * @brief   Retreive the offset between local clock and system synchronization signal.
+ *
+ * @return
+ */
+inline float aosSsspGetSyncSkew(void)
+{
+  return _syncskew;
+}
+
+#endif /* (AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true) */
+
 /**
  * @brief   Leave the operation pahse and initiate or acknowledge shutdown.
  *
@@ -656,7 +1288,7 @@ void aosSsspShutdownInit(bool active)
 
   // activate PD if this was an active shutdown initiation
   if (active) {
-    apalControlGpioSet(&moduleSsspGpioPD, APAL_GPIO_ON);
+    apalControlGpioSet(moduleSsspSignalPD(), APAL_GPIO_ON);
   }
 
 #if (AMIROOS_CFG_SSSP_MASTER == true)
@@ -665,7 +1297,7 @@ void aosSsspShutdownInit(bool active)
 #endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
 
   // activate S
-  apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_ON);
+  apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_ON);
 
   // proceed in the shutdown phase
   aos.sssp.stage = AOS_SSSP_STAGE_SHUTDOWN_1_2;
@@ -690,9 +1322,9 @@ void aosSsspShutdownBroadcastIdentifier(unsigned int identifier)
       aosThdUSleep(AOS_SSSP_DELAY);
 
       // activate S for one AOS_SSSP_DELAY.
-      apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_ON);
+      apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_ON);
       aosThdUSleep(AOS_SSSP_DELAY);
-      apalControlGpioSet(&moduleSsspGpioS, APAL_GPIO_OFF);
+      apalControlGpioSet(moduleSsspSignalS(), APAL_GPIO_OFF);
     }
   }
 
@@ -728,8 +1360,8 @@ eventmask_t aosSsspShutdownWaitForIdentifierPulse(event_listener_t* gpiolistener
 
   // arm the timer once
   if (!chVTIsArmed(&_delayTimer)) {
-    chEvtRegisterMask(&_eventSourceDelay, &_eventListenerDelay, timermask);
-    chVTSet(&_delayTimer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &_eventSourceDelay);
+    chEvtRegisterMask(&_delayEventSource, &_delayEventListener, timermask);
+    chVtSet(&_delayTimer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &_delayEventSource);
   }
 
   // wait for any event to occur (do not apply any filters in order not to miss any events)
@@ -739,23 +1371,22 @@ eventmask_t aosSsspShutdownWaitForIdentifierPulse(event_listener_t* gpiolistener
   if (mask & gpiolistener->events) {
     // retreive flags without clearing them
     flags = gpiolistener->flags;
-    apalControlGpioGet(&moduleSsspGpioS, &sstate);
+    apalControlGpioGet(moduleSsspSignalS(), &sstate);
     if (flags == sflags) {
-      apalControlGpioGet(&moduleSsspGpioS, &sstate);
+      apalControlGpioGet(moduleSsspSignalS(), &sstate);
       // if this was the end of a pulse
       if (sstate == APAL_GPIO_OFF) {
         // restart the timer
-        chVTReset(&_delayTimer);
-        chVTSet(&_delayTimer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &_eventSourceDelay);
+        chVtSet(&_delayTimer, chTimeUS2I(AOS_SSSP_TIMEOUT), _timerCallback, &_delayEventSource);
         // increment the identifier
         ++(*identifier);
       }
     }
   }
   // timer event
-  else if (mask & _eventListenerDelay.events) {
+  else if (mask & _delayEventListener.events) {
     // unregister event
-    chEvtUnregister(&_eventSourceDelay, &_eventListenerDelay);
+    chEvtUnregister(&_delayEventSource, &_delayEventListener);
   }
   // any further events must be handled externally
 
@@ -764,20 +1395,6 @@ eventmask_t aosSsspShutdownWaitForIdentifierPulse(event_listener_t* gpiolistener
 
 #endif /* (AMIROOS_CFG_SSSP_SHUTDOWN == true) */
 
-#if ((AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true)) || defined(__DOXYGEN__)
-
-/**
- * @brief   Retreive the offset between local clock and system synchronization signal.
- *
- * @return
- */
-float aosSsspGetSyncSkew(void)
-{
-  return _syncskew;
-}
-
-#endif /* (AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true) */
-
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
 /** @} */
diff --git a/core/src/aos_system.c b/core/src/aos_system.c
index 89b59e1..8a6b16a 100644
--- a/core/src/aos_system.c
+++ b/core/src/aos_system.c
@@ -276,15 +276,11 @@ static void _printSystemInfo(BaseSequentialStream* stream)
   // print dynamic information about the module
   _printSystemInfoSeparator(stream, '-', SYSTEM_INFO_WIDTH);
 #if (AMIROOS_CFG_SSSP_ENABLE == true)
-#if (AMIROOS_CFG_SSSP_MSI == true)
   if (aos.sssp.moduleId != 0) {
     _printSystemInfoLine(stream, "Module ID", SYSTEM_INFO_NAMEWIDTH, "%u", aos.sssp.moduleId);
   } else {
     _printSystemInfoLine(stream, "Module ID", SYSTEM_INFO_NAMEWIDTH, "not available");
   }
-#else /* (AMIROOS_CFG_SSSP_MSI == true) */
-  _printSystemInfoLine(stream, "Module ID", SYSTEM_INFO_NAMEWIDTH, "not available");
-#endif /* (AMIROOS_CFG_SSSP_MSI == true) */
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 #if (HAL_USE_RTC == TRUE)
   _printSystemInfoLine(stream, "Date", SYSTEM_INFO_NAMEWIDTH, "%04u-%02u-%02u (%s)",
diff --git a/modules/DiWheelDrive_1-1/aosconf.h b/modules/DiWheelDrive_1-1/aosconf.h
index fbac3a8..ba96e60 100644
--- a/modules/DiWheelDrive_1-1/aosconf.h
+++ b/modules/DiWheelDrive_1-1/aosconf.h
@@ -161,14 +161,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
  */
 #if !defined(OS_CFG_SSSP_MSI)
-  #define AMIROOS_CFG_SSSP_MSI                  false
+  #define AMIROOS_CFG_SSSP_MSI                  true
 #else
   #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
 #endif
 
 /**
  * @brief   Width of the @p aos_sssp_moduleid_t type.
- * @details Possible settings are 8, 16 and 32.
+ * @details Possible settings are 8, 16, 32 and 64.
  */
 #if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
   #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
diff --git a/modules/DiWheelDrive_1-1/module.c b/modules/DiWheelDrive_1-1/module.c
index b401687..9a7b912 100644
--- a/modules/DiWheelDrive_1-1/module.c
+++ b/modules/DiWheelDrive_1-1/module.c
@@ -24,7 +24,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @{
  */
 
-#include "module.h"
+#include <amiroos.h>
+
+#include <string.h>
 
 /*===========================================================================*/
 /**
@@ -352,6 +354,67 @@ ROMCONST char* moduleShellPrompt = "DiWheelDrive";
  */
 /*===========================================================================*/
 
+#if ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true)) || defined(__DOXYGEN__)
+
+/* some local definitions */
+// maximum number of bytes per CAN frame
+#define CAN_BYTES_PER_FRAME                     8
+// identifier (as dominant as possible)
+#define MSI_BCBMSG_CANID                        0
+
+aos_ssspbcbstatus_t moduleSsspBcbTransmit(const uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANTxFrame frame;
+
+  // setup the common parts of the message frame
+  frame.DLC = (uint8_t)length;
+  frame.RTR = CAN_RTR_DATA;
+  frame.IDE = CAN_IDE_STD;
+  frame.SID = MSI_BCBMSG_CANID;
+  memcpy(frame.data8, buffer, length);
+
+  // sent the frame and return
+  return (canTransmitTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) ? AOS_SSSP_BCB_SUCCESS : AOS_SSSP_BCB_ERROR;
+}
+
+aos_ssspbcbstatus_t moduleSsspBcbReceive(uint8_t* buffer, size_t length)
+{
+  aosDbgCheck(buffer != NULL);
+  aosDbgCheck(length > 0 && length <= CAN_BYTES_PER_FRAME);
+
+  // local variables
+  CANRxFrame frame;
+
+  // receive a frame and check for errors
+  if (canReceiveTimeout(&MODULE_HAL_CAN, CAN_ANY_MAILBOX, &frame, TIME_IMMEDIATE) == MSG_OK) {
+    // a correct frame was received
+    if (frame.DLC == length &&
+        frame.RTR == CAN_RTR_DATA &&
+        frame.IDE == CAN_IDE_STD &&
+        frame.SID == MSI_BCBMSG_CANID) {
+      // success: fetch the data and return
+      memcpy(buffer, frame.data8, length);
+      return AOS_SSSP_BCB_SUCCESS;
+    }
+    // an unexpected frame was received
+    else {
+      return AOS_SSSP_BCB_INVALIDMSG;
+    }
+  } else {
+    // failure: return with error
+    return AOS_SSSP_BCB_ERROR;
+  }
+}
+
+#undef MSI_BCBMSG_CANID
+#undef CAN_BYTES_PER_FRAME
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MSI == true) */
+
 /** @} */
 
 /*===========================================================================*/
diff --git a/modules/DiWheelDrive_1-1/module.h b/modules/DiWheelDrive_1-1/module.h
index efd3a02..0193b84 100644
--- a/modules/DiWheelDrive_1-1/module.h
+++ b/modules/DiWheelDrive_1-1/module.h
@@ -398,35 +398,14 @@ extern ROMCONST char* moduleShellPrompt;
  */
 /*===========================================================================*/
 
-/**
- * @brief   PD signal GPIO.
- */
-#define moduleSsspGpioPD                        moduleGpioSysPd
-
-/**
- * @brief   S signal GPIO.
- */
-#define moduleSsspGpioS                         moduleGpioSysSync
+#define moduleSsspSignalPD()                    (&moduleGpioSysPd)
+#define moduleSsspEventflagPD()                 MODULE_OS_GPIOEVENTFLAG_SYSPD
 
-/**
- * @brief   UP signal GPIO.
- */
-#define moduleSsspGpioUP                        moduleGpioSysUartUp
+#define moduleSsspSignalS()                     (&moduleGpioSysSync)
+#define moduleSsspEventflagS()                  MODULE_OS_GPIOEVENTFLAG_SYSSYNC
 
-/**
- * @brief   Event flag for PD signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_PD                MODULE_OS_GPIOEVENTFLAG_SYSPD
-
-/**
- * @brief   Event flag for S signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_S                 MODULE_OS_GPIOEVENTFLAG_SYSSYNC
-
-/**
- * @brief   Event flag for UP signal events.
- */
-#define MODULE_SSSP_EVENTFLAG_UP                MODULE_OS_GPIOEVENTFLAG_SYSUARTUP
+#define moduleSsspSignalUP()                    (&moduleGpioSysUartUp)
+#define moduleSsspEventflagUP()                 MODULE_OS_GPIOEVENTFLAG_SYSUARTUP
 
 /** @} */
 
diff --git a/modules/DiWheelDrive_1-2/aosconf.h b/modules/DiWheelDrive_1-2/aosconf.h
index 4d8765d..8bb97df 100644
--- a/modules/DiWheelDrive_1-2/aosconf.h
+++ b/modules/DiWheelDrive_1-2/aosconf.h
@@ -161,14 +161,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
  */
 #if !defined(OS_CFG_SSSP_MSI)
-  #define AMIROOS_CFG_SSSP_MSI                  false
+  #define AMIROOS_CFG_SSSP_MSI                  true
 #else
   #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
 #endif
 
 /**
  * @brief   Width of the @p aos_sssp_moduleid_t type.
- * @details Possible settings are 8, 16 and 32.
+ * @details Possible settings are 8, 16, 32 and 64.
  */
 #if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
   #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
